package stranded2.map.io;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;

public class SimpleReader {

	File mapFile;
	FileInputStream fileInputStream;
	BufferedReader reader;

	public SimpleReader(String path) throws FileNotFoundException,
			UnsupportedEncodingException {
		mapFile = new File(path);
		fileInputStream = new FileInputStream(mapFile);
		reader = new BufferedReader(new InputStreamReader(fileInputStream,
				"ISO-8859-1"));
	}

	public int read(char[] cbuf, int i, int j) throws IOException {
		return reader.read(cbuf, i, j);
	}

	public String readLine() throws IOException {
		return reader.readLine();
	}

	public Byte readByte() throws IOException {
		return (byte) reader.read();
	}

	public Integer readInt() throws IOException {
		char[] tab = new char[4];
		for (int k = 0; k < 4; k++) {
			tab[k] = (char) reader.read();
		}
		return tab[0] + tab[1] * 256 + tab[2] * 256 * 256 + tab[3] * 256 * 256
				* 256;
	}
	
	public Float readFloat() throws IOException {
		int intBits = readInt();
		return Float.intBitsToFloat(intBits);
	}

	public String readString() throws IOException {
		int length = readInt();
		String result = "";
		for (int k = 0; k < length; k++) {
			char readByte = (char) reader.read();
			result += readByte;
		}
		return result;
	}

}