package stranded2.map.io;

import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.util.Iterator;

import javax.imageio.ImageIO;
import javax.imageio.ImageWriter;
import javax.imageio.stream.ImageOutputStream;

public class TrueFalseImage {

	protected BufferedImage image;
	private char[] data;

	public TrueFalseImage(SimpleReader reader, int width, int height) throws IOException {
		image = new BufferedImage(width + 1, height + 1, BufferedImage.TYPE_INT_BGR);

		data = new char[(width+1)*(height+1)];
		
		for (int x = 0; x <= width; x++)
			for (int y = 0; y <= height; y++) {
				byte val = reader.readByte();
				data[x * (height+1) + y] = (char) (val<0?val+256:val);
				int g = val * 255;
				int rgb = 255 * 256 * 256 * 256 + 0 * 256 * 256 + g * 256 + 0;
				setImageData(x, y, rgb);
			}
	}

	public void setImageData(int x, int y, int rgb) {
		image.setRGB(x, y, rgb);
	}

	public void createBitmap(String path) throws IOException {
		Iterator<ImageWriter> imageWritersByFormatName = ImageIO.getImageWritersByFormatName("bmp");
		ImageWriter writer = imageWritersByFormatName.next();
		ImageOutputStream imageOutputStream = ImageIO.createImageOutputStream(new File(path));
		writer.setOutput(imageOutputStream);
		writer.write(image);
		imageOutputStream.close();
	}

	public void setData(char[] data) {
		this.data = data;
	}

	public char[] getData() {
		return data;
	}
}
